/***
* BSFFT1D is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
* 
* $LastChangedDate: 2016-05-20 13:54:36 +0200 (Fr, 20. Mai 2016) $
* $Author: melzer $
* $Revision: 6398 $
*
*/




/*
 * sparseFFT_1D.h
 *
 *  Created on: 02.05.2016
 *      Author: ines
 */

#ifndef SPARSEFFT1D_H_
#define SPARSEFFT1D_H_

#include <complex>
#include "tree1D.h"

typedef complex<double> dcomplex;
typedef Col<dcomplex> veccomplex;
typedef Mat<dcomplex> matcomplex;
#define I dcomplex(0.0,1.0)

class sparseFFT1D{

	friend class sparseFFT1D_mtimes;
public:
	//Methoden
	sparseFFT1D(vec *MX,vec *MOmega,unsigned int p, unsigned int N,string opt="showCopyInfo"); //Constructor
	~sparseFFT1D();//Destructor

    unsigned int N; //bandwidth
    vec * MX;//sampling nodes in the spatial domain [0,N]
    vec * MOmega;//sampling nodes in the frequency domain [0,N]
    unsigned int p; //approximation rank

private:
    //matrices for option Ltb,Ltb*
    //vector< vector< complex<double> >* > * Laglast; //function values of lagrange polynomials in MX (just for Ltb*)
    matcomplex Lleft;  //Lagrange matrix for a left son
    matcomplex Lright; //Lagrange matrix for a right son
    //Mat<cx_double> * Laglast;

	vec alpha; //Chebyshev grid  in [-1/2,1/2] for A
	vec beta; //equispaced grid  in [-1/2,1/2] for B

	//all variables, which are selecting from the trees
	vector<structLevelBox> * lastLevelA; //cellarray: last level of boxes A from T_X with rows:  {m,indices,(number of sons)}
	vector<structLevelBox> * lastLevelB; //cellarray: last level of boxes B from T_Omega with rows: {m,indices,number of sons}

	vector < vector<unsigned int>*> ABoxes; //vector of pointers to position vectors in each level
	vector < vector<structLevelParaB> *> BBoxes; //vector of pointers to positions of structLevelParaB for each level
	vector< unsigned int > numBoxesLevel; //number of boxes for each level L-l+1 of T_Omega as vector

	void showCopyright();
	//Lagrange polynomials
	void lagpol_z(veccomplex *pls, veccomplex *z,veccomplex *z_node,unsigned int k);
	void lagpol_alpha(veccomplex *pls,unsigned int sonType, unsigned int k);
};

#endif /* SPARSEFFT1D_H_ */
